#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
//#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h> 
#include <sys/time.h>  

#define MAX_MSG 0x260
#define MULTI_PORT 9522
#define CONTROL_PORT 5555
#define CONTROL_MG "234.1.1.1"
#define HTTP_PORT 7073

typedef struct smadata
  {
   char s; // 0x002a :42
   char m;
   char a; //000d6d0a8a00

   char o1[12]; // -56
   unsigned short PrID; // 0x6069 //16-17 //0x003a-3b
   char o2[2]; //18-19
   char zeitgeber[8] ; //20-27
   
   char o0_1_4_0[4];    char WirkleistungBezug[4];  
   char o0_1_8_0[4];    char WirkarbeitBezug[8]; 
   char o0_2_4_0[4];    char WirkleistungLieferung[4];
   char o0_2_8_0[4];    char WirkarbeitLieferung[8];
   char o0_3_4_0[4];    char BlindleistungBezug[4];
   char o0_3_8_0[4];    char BlindarbeitBezug[8]; 
   char o0_4_4_0[4];    char BlindleistungLieferung[4]; 
   char o0_4_8_0[4];    char BlindarbeitLieferung[8];   
   char o0_9_4_0[4];    char ScheinleistungBezug[4];  
   char o0_9_8_0[4];    char ScheinarbeitBezug[8]; 
   char o0_10_4_0[4];   char ScheinleistungLieferung[4];  
   char o0_10_8_0[4];   char ScheinarbeitLieferung[8];   
   char o0_13_4_0[4];   char Leistungsfaktor[4];  
          
   char o0_21_4_0[4];    char L1WirkleistungBezug[4];  
   char o0_21_8_0[4];    char L1WirkarbeitBezug[8]; 
   char o0_22_4_0[4];    char L1WirkleistungLieferung[4];
   char o0_22_8_0[4];    char L1WirkarbeitLieferung[8];
   char o0_23_4_0[4];    char L1BlindleistungBezug[4];
   char o0_23_8_0[4];    char L1BlindarbeitBezug[8]; 
   char o0_24_4_0[4];    char L1BlindleistungLieferung[4]; 
   char o0_24_8_0[4];    char L1BlindarbeitLieferung[8];   
   char o0_29_4_0[4];    char L1ScheinleistungBezug[4];  
   char o0_29_8_0[4];    char L1ScheinarbeitBezug[8]; 
   char o0_30_4_0[4];    char L1ScheinleistungLieferung[4];  
   char o0_30_8_0[4];    char L1ScheinarbeitLieferung[8];   
   char o0_31_4_0[4];    char L1Strom[4];  
   char o0_32_4_0[4];    char L1Spannung[4];  
   char o0_33_4_0[4];    char L1Leistungsfaktor[4];     
   
   char o0_41_4_0[4];    char L2WirkleistungBezug[4];  
   char o0_41_8_0[4];    char L2WirkarbeitBezug[8]; 
   char o0_42_4_0[4];    char L2WirkleistungLieferung[4];
   char o0_42_8_0[4];    char L2WirkarbeitLieferung[8];
   char o0_43_4_0[4];    char L2BlindleistungBezug[4];
   char o0_43_8_0[4];    char L2BlindarbeitBezug[8]; 
   char o0_44_4_0[4];    char L2BlindleistungLieferung[4]; 
   char o0_44_8_0[4];    char L2BlindarbeitLieferung[8];   
   char o0_49_4_0[4];    char L2ScheinleistungBezug[4];  
   char o0_49_8_0[4];    char L2ScheinarbeitBezug[8]; 
   char o0_50_4_0[4];    char L2ScheinleistungLieferung[4];  
   char o0_50_8_0[4];    char L2ScheinarbeitLieferung[8];   
   char o0_51_4_0[4];    char L2Strom[4];  
   char o0_52_4_0[4];    char L2Spannung[4];  
   char o0_53_4_0[4];    char L2Leistungsfaktor[4];     
   
   char o0_61_4_0[4];    char L3WirkleistungBezug[4];  
   char o0_61_8_0[4];    char L3WirkarbeitBezug[8]; 
   char o0_62_4_0[4];    char L3WirkleistungLieferung[4];
   char o0_62_8_0[4];    char L3WirkarbeitLieferung[8];
   char o0_63_4_0[4];    char L3BlindleistungBezug[4];
   char o0_63_8_0[4];    char L3BlindarbeitBezug[8]; 
   char o0_64_4_0[4];    char L3BlindleistungLieferung[4]; 
   char o0_64_8_0[4];    char L3BlindarbeitLieferung[8];   
   char o0_69_4_0[4];    char L3ScheinleistungBezug[4];  
   char o0_69_8_0[4];    char L3ScheinarbeitBezug[8]; 
   char o0_70_4_0[4];    char L3ScheinleistungLieferung[4];  
   char o0_70_8_0[4];    char L3ScheinarbeitLieferung[8];   
   char o0_71_4_0[4];    char L3Strom[4];  
   char o0_72_4_0[4];    char L3Spannung[4];  
   char o0_73_4_0[4];    char L3Leistungsfaktor[4];    
 
 } SMADATA;

static void daemonize(void);
int send2fhem();
long B8_2long(char *);
long B4_2long(char *);
double Strom(char *);
double Spannung(char *);
double Leistung(char *);
long byteArrayToLong(char* , int);
void err_dump(char *s);
void sendIt(char msg[],int outFd);
void takeIt(char msg[],int inFd);
void Leistung2(char *,char *,int);
void Spannung2(char *,char *,int);
void Arbeit2(char *,char *,int);
int counter = 0;
char msg[MAX_MSG];
char msg_old[MAX_MSG];

char command[5000];


int main(int argc, char *argv[]) {
  daemonize();
  int infd, rc,cliLen,ret,one=1;
  struct sockaddr_in inAddr,cliAddr,controlAddr ; 
  struct in_addr mcastAddr;

  char multicasthost[30];
  
  struct ip_mreq mreq;
  fd_set read_mask;
  
  SMADATA *smad;
  smad=(SMADATA *)msg;
  //SMADATA *smad_old;
  //smad_old=msg_old;
  
  sprintf(multicasthost,"239.12.255.254");

  
  //set up UDP socket to receive for this process
  memset(&inAddr,0,sizeof(inAddr));
  inAddr.sin_family = AF_INET;
  inAddr.sin_addr.s_addr = inet_addr(multicasthost);
  inAddr.sin_port = htons(MULTI_PORT);
  //puts("start smarttcp...");
  /* create UDP socket to receive*/
  infd = (int)socket(AF_INET,SOCK_DGRAM,0);
  if (infd<0) {
    printf("%s : cannot open socket\n",argv[0]);
    return(1);
  }
  
  /* bind to receive data on mutlicast port number */
  /* need to tell bind that multpile processes can bind to the same port*/
  setsockopt(infd,SOL_SOCKET,SO_REUSEADDR,&one,sizeof(one));
  if(bind(infd,(struct sockaddr *) &inAddr,sizeof(inAddr))<0) {
    perror("bind");
    return(1);
  }

  /* join multicast group */
  mreq.imr_multiaddr.s_addr=inet_addr(multicasthost);
  mreq.imr_interface.s_addr=htonl(INADDR_ANY);  
  rc = setsockopt(infd,IPPROTO_IP,IP_ADD_MEMBERSHIP,
		  (void *) &mreq, sizeof(mreq));
  if(rc<0) {
    printf("%s : cannot join multicast group '%s'",argv[0],
	   inet_ntoa(mcastAddr));
    return(1);
  }
  
   memset(&controlAddr,0,sizeof(controlAddr));
   controlAddr.sin_family = AF_INET;
   controlAddr.sin_addr.s_addr = inet_addr(CONTROL_MG);
   controlAddr.sin_port = htons(CONTROL_PORT);
   ///////////////////////////////////////////////////////////////////////////////////////  
   //daemonize();
   while(1){
      if(++counter>3600)counter=1;
      FD_ZERO(&read_mask);
      FD_SET(infd, &read_mask);
      //FD_SET(0, &read_mask);
      if ((ret = select(32, &read_mask, 0, 0, 0)) < 0)
      err_dump("select");
      if (1/*!FD_ISSET(0,&read_mask) */)

      {
        cliLen=sizeof(cliAddr);
        recvfrom(infd,msg,MAX_MSG,0,(struct sockaddr *) &cliAddr, (socklen_t *)&cliLen);
        
        //int arbeit=23;
        sprintf(command,";");
        Leistung2(smad->WirkleistungBezug,      "SummeWirkleistungBezug"       ,10);
        Arbeit2(smad->WirkarbeitBezug,          "SummeWirkarbeitBezug"         ,300);        
        Arbeit2(smad->WirkarbeitLieferung,      "SummeWirkarbeitLieferung"     ,300); 
        Arbeit2(smad->L1WirkarbeitBezug,        "L1WirkarbeitBezug"         ,300);        
        Arbeit2(smad->L2WirkarbeitBezug,        "L2WirkarbeitBezug"         ,300);        
        Arbeit2(smad->L3WirkarbeitBezug,        "L3WirkarbeitBezug"         ,300);        
        Arbeit2(smad->L1WirkarbeitLieferung,    "L1WirkarbeitLieferung"         ,300);
        Arbeit2(smad->L2WirkarbeitLieferung,    "L2WirkarbeitLieferung"         ,300);
        Arbeit2(smad->L3WirkarbeitLieferung,    "L3WirkarbeitLieferung"         ,300);
                   
        Leistung2(smad->WirkleistungLieferung,  "SummeWirkleistungLieferung"   ,10);
        Leistung2(smad->BlindleistungBezug,     "SummeBlindleistungBezug"     ,300);
        Leistung2(smad->BlindleistungLieferung, "SummeBlindleistungLieferung" ,300);
        Leistung2(smad->ScheinleistungBezug,    "SummeScheinleistungBezug"    ,300);
        Leistung2(smad->ScheinleistungLieferung,"SummeScheinleistungLieferung",300);
        Leistung2(smad->L1WirkleistungBezug,      "L1WirkleistungBezug"       ,10);
        Leistung2(smad->L1WirkleistungLieferung,  "L1WirkleistungLieferung"   ,10);
        Leistung2(smad->L1BlindleistungBezug,     "L1BlindleistungBezug"     ,300);
        Leistung2(smad->L1BlindleistungLieferung, "L1BlindleistungLieferung" ,300);
        Leistung2(smad->L1ScheinleistungBezug,    "L1ScheinleistungBezug"    ,300);
        Leistung2(smad->L1ScheinleistungLieferung,"L1ScheinleistungLieferung",300);   
        Leistung2(smad->L2WirkleistungBezug,      "L2WirkleistungBezug"       ,10);
        Leistung2(smad->L2WirkleistungLieferung,  "L2WirkleistungLieferung"   ,300);
        Leistung2(smad->L2BlindleistungBezug,     "L2BlindleistungBezug"     ,300);
        Leistung2(smad->L2BlindleistungLieferung, "L2BlindleistungLieferung" ,300);
        Leistung2(smad->L2ScheinleistungBezug,    "L2ScheinleistungBezug"    ,300);
        Leistung2(smad->L2ScheinleistungLieferung,"L2ScheinleistungLieferung",300);        
        Leistung2(smad->L3WirkleistungBezug,      "L3WirkleistungBezug"       ,10);
        Leistung2(smad->L3WirkleistungLieferung,  "L3WirkleistungLieferung"   ,300);
        Leistung2(smad->L3BlindleistungBezug,     "L3BlindleistungBezug"     ,300);
        Leistung2(smad->L3BlindleistungLieferung, "L3BlindleistungLieferung" ,300);
        Leistung2(smad->L3ScheinleistungBezug,    "L3ScheinleistungBezug"    ,300);
        Leistung2(smad->L3ScheinleistungLieferung,"L3ScheinleistungLieferung",300);  
        Spannung2(smad->L1Spannung,               "L1Spannung"             ,600);  
        Spannung2(smad->L2Spannung,               "L2Spannung"             ,600);  
        Spannung2(smad->L3Spannung,               "L3Spannung"             ,600);  
        if(strlen(command)>4)send2fhem();
        //puts(command);
        
      /*  if(arbeit&1)sprintf(command+strlen(command),"set SummeWirkleistungBezug %6.1f ; ",Leistung(smad->WirkleistungBezug));
        if(arbeit&128)sprintf(command+strlen(command),"set SummeWirkarbeitBezug %lu ; ",byteArrayToLong(smad->WirkarbeitBezug,0));
        if(arbeit&1)sprintf(command+strlen(command),"set SummeWirkleistungLieferung %6.1f ; ",Leistung(smad->WirkleistungLieferung));
        if(arbeit&128)sprintf(command+strlen(command),"set SummeWirkarbeitLieferung %lu ; ",byteArrayToLong(smad->WirkarbeitLieferung,0));
        if(arbeit&2)sprintf(command+strlen(command),"set SummeBlindleistungBezug %6.1f ; ",Leistung(smad->BlindleistungBezug));
        if(arbeit&128)sprintf(command+strlen(command),"set SummeBlindarbeitBezug %lu ; ",byteArrayToLong(smad->BlindarbeitBezug,0));
        if(arbeit&2)sprintf(command+strlen(command),"set SummeBlindleistungLieferung %6.1f ; ",Leistung(smad->BlindleistungLieferung));
        if(arbeit&128)sprintf(command+strlen(command),"set SummeBlindarbeitLieferung %lu ; ",byteArrayToLong(smad->BlindarbeitLieferung,0));
        if(arbeit&2)sprintf(command+strlen(command),"set SummeScheinleistungBezug %6.1f ; ",Leistung(smad->ScheinleistungBezug));
        if(arbeit&128)sprintf(command+strlen(command),"set SummeScheinarbeitBezug %lu ; ",byteArrayToLong(smad->ScheinarbeitBezug,0));
        if(arbeit&2)sprintf(command+strlen(command),"set SummeScheinleistungLieferung %6.1f ; ",Leistung(smad->ScheinleistungLieferung));
        if(arbeit&128)sprintf(command+strlen(command),"set SummeScheinarbeitLieferung %lu ; ",byteArrayToLong(smad->ScheinarbeitLieferung,0));
        if(arbeit&2)sprintf(command+strlen(command),"set SummeLeistungsfaktor %ld ; ",B4_2long(smad->Leistungsfaktor));
        //puts("-L1---------------------------------------");
        if(arbeit&4)sprintf(command+strlen(command),"set L1WirkleistungBezug %6.1f ; ",Leistung(smad->L1WirkleistungBezug));
        if(arbeit&128)sprintf(command+strlen(command),"set L1WirkarbeitBezug %lu ; ",byteArrayToLong(smad->L1WirkarbeitBezug,0));
        if(arbeit&4)sprintf(command+strlen(command),"set L1WirkleistungLieferung %6.1f ; ",Leistung(smad->L1WirkleistungLieferung));
        if(arbeit&128)sprintf(command+strlen(command),"set L1WirkarbeitLieferung %lu ; ",byteArrayToLong(smad->L1WirkarbeitLieferung,0));
        if(arbeit&8)sprintf(command+strlen(command),"set L1BlindleistungBezug %6.1f ; ",Leistung(smad->L1BlindleistungBezug));
        if(arbeit&128)sprintf(command+strlen(command),"set L1BlindarbeitBezug %lu ; ",byteArrayToLong(smad->L1BlindarbeitBezug,0));
        if(arbeit&8)sprintf(command+strlen(command),"set L1BlindleistungLieferung %6.1f ; ",Leistung(smad->L1BlindleistungLieferung));
        if(arbeit&128)sprintf(command+strlen(command),"set L1BlindarbeitLieferung %lu ; ",byteArrayToLong(smad->L1BlindarbeitLieferung,0));
        if(arbeit&8)sprintf(command+strlen(command),"set L1ScheinleistungBezug %6.1f ; ",Leistung(smad->L1ScheinleistungBezug));
        if(arbeit&8)sprintf(command+strlen(command),"set L1ScheinarbeitBezug %lu ; ",byteArrayToLong(smad->L1ScheinarbeitBezug,0));
        if(arbeit&8)sprintf(command+strlen(command),"set L1ScheinleistungLieferung %6.1f ; ",Leistung(smad->L1ScheinleistungLieferung));
        if(arbeit&128)sprintf(command+strlen(command),"set L1ScheinarbeitLieferung %lu ; ",byteArrayToLong(smad->L1ScheinarbeitLieferung,0));
        if(arbeit&16)sprintf(command+strlen(command),"set L1Strom %6g ; ",Strom(smad->L1Strom));
        if(arbeit&16)sprintf(command+strlen(command),"set L1Spannung %6g ; ",Spannung(smad->L1Spannung));
        if(arbeit&16)sprintf(command+strlen(command),"set L1Leistungsfaktor %ld ; ",B4_2long(smad->L1Leistungsfaktor));

        //puts("-L2---------------------------------------");
        if(arbeit&4)sprintf(command+strlen(command),"set L2WirkleistungBezug %6.1f ; ",Leistung(smad->L2WirkleistungBezug));
        if(arbeit&128)sprintf(command+strlen(command),"set L2WirkarbeitBezug %lu ; ",byteArrayToLong(smad->L2WirkarbeitBezug,0));
        if(arbeit&4)sprintf(command+strlen(command),"set L2WirkleistungLieferung %6.1f ; ",Leistung(smad->L2WirkleistungLieferung));
        if(arbeit&128)sprintf(command+strlen(command),"set L2WirkarbeitLieferung %lu ; ",byteArrayToLong(smad->L2WirkarbeitLieferung,0));
        if(arbeit&8)sprintf(command+strlen(command),"set L2BlindleistungBezug %6.1f ; ",Leistung(smad->L2BlindleistungBezug));
        if(arbeit&8)sprintf(command+strlen(command),"set L2BlindarbeitBezug %lu ; ",byteArrayToLong(smad->L2BlindarbeitBezug,0));
        if(arbeit&8)sprintf(command+strlen(command),"set L2BlindleistungLieferung %6.1f ; ",Leistung(smad->L2BlindleistungLieferung));
        if(arbeit&128)sprintf(command+strlen(command),"set L2BlindarbeitLieferung %lu ; ",byteArrayToLong(smad->L2BlindarbeitLieferung,0));
        if(arbeit&8)sprintf(command+strlen(command),"set L2ScheinleistungBezug %6.1f ; ",Leistung(smad->L2ScheinleistungBezug));
        if(arbeit&128)sprintf(command+strlen(command),"set L2ScheinarbeitBezug %lu ; ",byteArrayToLong(smad->L2ScheinarbeitBezug,0));
        if(arbeit&8)sprintf(command+strlen(command),"set L2ScheinleistungLieferung %6.1f ; ",Leistung(smad->L2ScheinleistungLieferung));
        if(arbeit&128)sprintf(command+strlen(command),"set L2ScheinarbeitLieferung %lu ; ",byteArrayToLong(smad->L2ScheinarbeitLieferung,0));
        if(arbeit&16)sprintf(command+strlen(command),"set L2Strom %6g ; ",Strom(smad->L2Strom));
        if(arbeit&16)sprintf(command+strlen(command),"set L2Spannung %6g ; ",Spannung(smad->L2Spannung));
        if(arbeit&16)sprintf(command+strlen(command),"set L2Leistungsfaktor %ld ; ",B4_2long(smad->L2Leistungsfaktor));
        //if(arbeit&128)sprintf(command+strlen(command),"set t0-7 %0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x ; ",smad->t0,smad->t1,smad->t2,smad->t3,smad->t4,smad->t5,smad->t6,smad->t7);
        //puts("-L3---------------------------------------");
        if(arbeit&4)sprintf(command+strlen(command),"set L3WirkleistungBezug %6.1f ; ",Leistung(smad->L3WirkleistungBezug));
        if(arbeit&128)sprintf(command+strlen(command),"set L3WirkarbeitBezug %lu ; ",byteArrayToLong(smad->L3WirkarbeitBezug,0));
        if(arbeit&4)sprintf(command+strlen(command),"set L3WirkleistungLieferung %6.1f ; ",Leistung(smad->L3WirkleistungLieferung));
        if(arbeit&128)sprintf(command+strlen(command),"set L3WirkarbeitLieferung %lu ; ",byteArrayToLong(smad->L3WirkarbeitLieferung,0));
        if(arbeit&8)sprintf(command+strlen(command),"set L3BlindleistungBezug %6.1f ; ",Leistung(smad->L3BlindleistungBezug));
        if(arbeit&128)sprintf(command+strlen(command),"set L3BlindarbeitBezug %lu ; ",byteArrayToLong(smad->L3BlindarbeitBezug,0));
        if(arbeit&8)sprintf(command+strlen(command),"set L3BlindleistungLieferung %6.1f ; ",Leistung(smad->L3BlindleistungLieferung));
        if(arbeit&128)sprintf(command+strlen(command),"set L3BlindarbeitLieferung %lu ; ",byteArrayToLong(smad->L3BlindarbeitLieferung,0));
        if(arbeit&8)sprintf(command+strlen(command),"set L3ScheinleistungBezug %6.1f ; ",Leistung(smad->L3ScheinleistungBezug));
        if(arbeit&128)sprintf(command+strlen(command),"set L3ScheinarbeitBezug %lu ; ",byteArrayToLong(smad->L3ScheinarbeitBezug,0));
        if(arbeit&8)sprintf(command+strlen(command),"set L3ScheinleistungLieferung %6.1f ; ",Leistung(smad->L3ScheinleistungLieferung));
        if(arbeit&128)sprintf(command+strlen(command),"set L3ScheinarbeitLieferung %lu ; ",byteArrayToLong(smad->L3ScheinarbeitLieferung,0));
        if(arbeit&16)sprintf(command+strlen(command),"set L3Strom %6g ; ",Strom(smad->L3Strom));
        if(arbeit&16)sprintf(command+strlen(command),"set L3Spannung %6g ; ",Spannung(smad->L3Spannung));
        if(arbeit&16)sprintf(command+strlen(command),"set L3Leistungsfaktor %ld ; ",B4_2long(smad->L3Leistungsfaktor));*/
        
        // Copy in old
        //for(i=0;i<MAX_MSG;i++)msg_old[i]=msg[i];  

    }
    
  } //while for waiting for multicast packets  
    close(infd);
    //close(outfd);
    return(0);
}
int send2fhem()
{
    int sock;
    struct sockaddr_in host_addr;
    struct hostent *hostinfo;
    char host[20];

    char buf[1024];
    unsigned int bytes_sent, bytes_recv;
    /* Wohin sende ich? */
    sprintf (host, "localhost");
    /* Socket erzeugen */
    sock = socket (AF_INET, SOCK_STREAM, 0);
    if (sock == -1) {
      perror ("socket()");
    return (EXIT_FAILURE);
    }
    /* Adresse des Servers festlegen */
    memset( &host_addr, 0, sizeof (host_addr));
    host_addr.sin_family = AF_INET;
    host_addr.sin_port = htons (HTTP_PORT);
    host_addr.sin_addr.s_addr = inet_addr (host);
    if (host_addr.sin_addr.s_addr == INADDR_NONE) {
    /* Server wurde nicht mit IP sondern mit dem Namen angegeben */
    hostinfo = gethostbyname (host);
    if (hostinfo == NULL) {
      perror ("gethostbyname()");
    return (EXIT_FAILURE);
    }
    memcpy((char*) &host_addr.sin_addr.s_addr, hostinfo->h_addr, hostinfo->h_length);
    }
    /* Verbindung aufbauen */
    if (connect(sock, (struct sockaddr *) &host_addr, sizeof(struct sockaddr)) == -1) {
      perror ("connect()");
    return (EXIT_FAILURE);
    }
    bytes_sent = send (sock, command, strlen (command), 0);
    if (bytes_sent == -1) {
      perror ("send()");
    return (EXIT_FAILURE);
    }
    sprintf (command, "exit\n");
    bytes_sent = send (sock, command, strlen (command), 0);
    if (bytes_sent == -1) {
      perror ("send()");
    return (EXIT_FAILURE);
    }
    // Antwort des Servers empfangen und ausgeben */
    while ((bytes_recv = recv (sock, buf, sizeof(buf), 0)) > 0) {
    write (1, buf, bytes_recv);
    }
    if (bytes_recv == -1) {
     perror ("recv()");
     return (EXIT_FAILURE);
    }

    close(sock);
    //printf ("success\n");
    return 0;
}
void err_dump(char *s){
  return;
}
long B8_2long(char *B8){
 int s=0;
  return (long)(B8[s+4]*16777216)+(B8[s+5]*65536)+(B8[s+6]*256)+B8[s+7];
}
long B4_2long(char *B4){
 int s=0;
  return (long)(B4[s+0]*16777216)+(B4[s+1]*65536)+(B4[s+2]*256)+B4[s+3];
}
double Strom(char *B4){
 int s=0;
  return (double)((B4[s+0]*16777216)+(B4[s+1]*65536)+(B4[s+2]*256)+B4[s+3])/1000.;
}
double Spannung(char *B4){
 int s=0;
  return (double)((B4[s+0]*16777216)+(B4[s+1]*65536)+(B4[s+2]*256)+B4[s+3])/1000.;
}
double Leistung(char *B4){
 int s=0;
  return (double)((B4[s+0]*16777216)+(B4[s+1]*65536)+(B4[s+2]*256)+B4[s+3])/10.;
}
void Leistung2(char *B4,char *text,int divisor){
 int s=0;
 int i=0;
 double v=0.;
 double v_old=0.;
 char *B4_old;
 if(((counter%divisor)!=0))return;
 B4_old=(B4-msg)+msg_old;
 v_old=(double)((B4_old[s+0]*16777216)+(B4_old[s+1]*65536)+(B4_old[s+2]*256)+B4_old[s+3])/10.;
 v=(double)((B4[s+0]*16777216)+(B4[s+1]*65536)+(B4[s+2]*256)+B4[s+3])/10.;
 if(((counter%divisor)==0)&&((int)v!=(int)v_old))sprintf(command+strlen(command),"set %s %6.1f;",text,v);
 for(i=0;i<4;i++)B4_old[i]=B4[i];  
 }
void Spannung2(char *B4,char *text,int divisor){
  int s=0;
 int i=0;
 double v=0.;
 double v_old=0.;
 char *B4_old;
 if(((counter%divisor)!=0))return;
 B4_old=(B4-msg)+msg_old;
 v_old=(double)((B4_old[s+0]*16777216)+(B4_old[s+1]*65536)+(B4_old[s+2]*256)+B4_old[s+3])/1000.;
 v=(double)((B4[s+0]*16777216)+(B4[s+1]*65536)+(B4[s+2]*256)+B4[s+3])/1000.;
 if(((counter%divisor)==0)&&((int)(v*10.)!=(int)(v_old*10.)))sprintf(command+strlen(command),"set %s %6g;",text,v);
 for(i=0;i<4;i++)B4_old[i]=B4[i]; 
} 
void Arbeit2(char *B8,char *text,int divisor){
  int s=0;
 int i=0;
 double v=0.;
 double v_old=0.;
 char *B8_old;
 if(((counter%divisor)!=0))return;
 B8_old=(B8-msg)+msg_old;

 v=B8[s+7];
 v+=B8[s+6]*pow(2,8);
 v+=B8[s+5]*pow(2,16);
 v+=B8[s+4]*pow(2,24);
 v+=B8[s+3]*pow(2,32);
 v+=B8[s+2]*pow(2,40);
 v+=B8[s+1]*pow(2,48);
 v_old=B8_old[s+7];
 v_old+=B8_old[s+6]*pow(2,8);
 v_old+=B8_old[s+5]*pow(2,16);
 v_old+=B8_old[s+4]*pow(2,24);
 v_old+=B8_old[s+3]*pow(2,32);
 v_old+=B8_old[s+2]*pow(2,40);
 v_old+=B8_old[s+1]*pow(2,48);
if(v!=v_old) sprintf(command+strlen(command),"set %s %6.1f;",text,v/1000000.);
//if(v!=v_old) sprintf(command+strlen(command),"set %s 0x%x%x%x%x%x%x%x%x;",text,B8[s+7],B8[s+6],B8[s+5],B8[s+4],B8[s+3],B8[s+2],B8[s+1],B8[s]);
 for(i=0;i<8;i++)B8_old[i]=B8[i]; 
}   
long byteArrayToLong(char* b, int offset) {
  long value = 0;
  int i;
  for (i = 0; i <8; i++) {
    int shift = (8 - 1 - i) * 8;
    value += (b[i + offset] & 0xFFFFFFFL) << shift  ;
  }
  return value;
 
}

static void daemonize(void)
{
    pid_t pid, sid;

    /* already a daemon */
    if ( getppid() == 1 ) return;

    /* Fork off the parent process */
    pid = fork();
    if (pid < 0) {
        exit(EXIT_FAILURE);
    }
    /* If we got a good PID, then we can exit the parent process. */
    if (pid > 0) {
        exit(EXIT_SUCCESS);
    }

    /* At this point we are executing as the child process */

    /* Change the file mode mask */
    umask(0);

    /* Create a new SID for the child process */
    sid = setsid();
    if (sid < 0) {
        exit(EXIT_FAILURE);
    }

    /* Change the current working directory.  This prevents the current
       directory from being locked; hence not being able to remove it. */
    if ((chdir("/")) < 0) {
        exit(EXIT_FAILURE);
    }

    /* Redirect standard files to /dev/null */
    freopen( "/dev/null", "r", stdin);
    freopen( "/dev/null", "w", stdout);
    freopen( "/dev/null", "w", stderr);
}
